/* util-email.c generated by valac 0.44.3, the Vala compiler
 * generated from util-email.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

gint util_email_compare_conversation_ascending (GearyAppConversation* a,
                                                GearyAppConversation* b);
gint util_email_compare_conversation_descending (GearyAppConversation* a,
                                                 GearyAppConversation* b);
gchar* util_email_strip_subject_prefixes (GearyEmail* email);
GearyRFC822MailboxAddress* util_email_get_primary_originator (GearyEmailHeaderSet* email);
gchar* util_email_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

gint
util_email_compare_conversation_ascending (GearyAppConversation* a,
                                           GearyAppConversation* b)
{
	gint result = 0;
	GearyEmail* a_latest = NULL;
	GearyEmail* _tmp0_;
	GearyEmail* b_latest = NULL;
	GearyEmail* _tmp1_;
	GearyEmail* _tmp2_;
	GearyEmail* _tmp6_;
	GearyEmail* _tmp7_;
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (a), 0);
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (b), 0);
	_tmp0_ = geary_app_conversation_get_latest_recv_email (a, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
	a_latest = _tmp0_;
	_tmp1_ = geary_app_conversation_get_latest_recv_email (b, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
	b_latest = _tmp1_;
	_tmp2_ = a_latest;
	if (_tmp2_ == NULL) {
		gint _tmp3_ = 0;
		GearyEmail* _tmp4_;
		_tmp4_ = b_latest;
		if (_tmp4_ == NULL) {
			_tmp3_ = 0;
		} else {
			_tmp3_ = -1;
		}
		result = _tmp3_;
		_g_object_unref0 (b_latest);
		_g_object_unref0 (a_latest);
		return result;
	} else {
		GearyEmail* _tmp5_;
		_tmp5_ = b_latest;
		if (_tmp5_ == NULL) {
			result = 1;
			_g_object_unref0 (b_latest);
			_g_object_unref0 (a_latest);
			return result;
		}
	}
	_tmp6_ = a_latest;
	_tmp7_ = b_latest;
	result = geary_email_compare_recv_date_ascending (_tmp6_, _tmp7_);
	_g_object_unref0 (b_latest);
	_g_object_unref0 (a_latest);
	return result;
}

gint
util_email_compare_conversation_descending (GearyAppConversation* a,
                                            GearyAppConversation* b)
{
	gint result = 0;
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (a), 0);
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (b), 0);
	result = util_email_compare_conversation_ascending (b, a);
	return result;
}

/** Returns the stripped subject line, or a placeholder if none. */
gchar*
util_email_strip_subject_prefixes (GearyEmail* email)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	GearyRFC822Subject* _tmp1_;
	GearyRFC822Subject* _tmp2_;
	gchar* cleaned = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	gchar* _tmp10_;
	g_return_val_if_fail (GEARY_IS_EMAIL (email), NULL);
	_tmp1_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		GearyRFC822Subject* _tmp3_;
		GearyRFC822Subject* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
		_tmp4_ = _tmp3_;
		_tmp5_ = geary_rf_c822_subject_strip_prefixes (_tmp4_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	_tmp6_ = g_strdup (_tmp0_);
	cleaned = _tmp6_;
	_tmp8_ = cleaned;
	if (!geary_string_is_empty (_tmp8_)) {
		const gchar* _tmp9_;
		_tmp9_ = cleaned;
		_tmp7_ = _tmp9_;
	} else {
		_tmp7_ = _ ("(no subject)");
	}
	_tmp10_ = g_strdup (_tmp7_);
	result = _tmp10_;
	_g_free0 (cleaned);
	_g_free0 (_tmp0_);
	return result;
}

/**
     * Returns a mailbox for the primary originator of an email.
     *
     * RFC 822 allows multiple and absent From header values, and
     * software such as Mailman and GitLab will mangle the names in
     * From mailboxes. This provides a canonical means to obtain a
     * mailbox (that is, name and email address) for the first
     * originator, and with the mailbox's name having been fixed up
     * where possible.
     *
     * The first From mailbox is used and de-mangled if found, if not
     * the Sender mailbox is used if present, else the first Reply-To
     * mailbox is used.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

GearyRFC822MailboxAddress*
util_email_get_primary_originator (GearyEmailHeaderSet* email)
{
	GearyRFC822MailboxAddress* result = NULL;
	GearyRFC822MailboxAddress* primary = NULL;
	gboolean _tmp0_ = FALSE;
	GearyRFC822MailboxAddresses* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
	g_return_val_if_fail (GEARY_IS_EMAIL_HEADER_SET (email), NULL);
	primary = NULL;
	_tmp1_ = geary_email_header_set_get_from (email);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		GearyRFC822MailboxAddresses* _tmp3_;
		GearyRFC822MailboxAddresses* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		_tmp3_ = geary_email_header_set_get_from (email);
		_tmp4_ = _tmp3_;
		_tmp5_ = geary_rf_c822_mailbox_addresses_get_size (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_ > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GearyRFC822MailboxAddresses* from = NULL;
		GearyRFC822MailboxAddresses* _tmp7_;
		GearyRFC822MailboxAddresses* _tmp8_;
		GearyRFC822MailboxAddresses* _tmp9_;
		gchar* from_name = NULL;
		gchar* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp12_;
		GearyRFC822MailboxAddresses* reply_to = NULL;
		GearyRFC822MailboxAddresses* _tmp23_;
		GearyRFC822MailboxAddresses* _tmp24_;
		GearyRFC822MailboxAddresses* _tmp25_;
		GearyRFC822MailboxAddress* primary_reply_to = NULL;
		gchar* reply_to_name = NULL;
		gchar* _tmp26_;
		gboolean _tmp27_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp28_;
		static const char VIA[] = " via ";
		gboolean _tmp39_ = FALSE;
		const gchar* _tmp40_;
		_tmp7_ = geary_email_header_set_get_from (email);
		_tmp8_ = _tmp7_;
		_tmp9_ = _g_object_ref0 (_tmp8_);
		from = _tmp9_;
		_tmp10_ = g_strdup ("");
		from_name = _tmp10_;
		_tmp12_ = from;
		if (_tmp12_ != NULL) {
			GearyRFC822MailboxAddresses* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			_tmp13_ = from;
			_tmp14_ = geary_rf_c822_mailbox_addresses_get_size (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp11_ = _tmp15_ > 0;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			GearyRFC822MailboxAddresses* _tmp16_;
			GearyRFC822MailboxAddress* _tmp17_;
			const gchar* _tmp18_ = NULL;
			GearyRFC822MailboxAddress* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			_tmp16_ = from;
			_tmp17_ = geary_rf_c822_mailbox_addresses_get (_tmp16_, 0);
			_g_object_unref0 (primary);
			primary = _tmp17_;
			_tmp19_ = primary;
			_tmp20_ = geary_rf_c822_mailbox_address_get_name (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp18_ = _tmp21_;
			if (_tmp18_ == NULL) {
				_tmp18_ = "";
			}
			_tmp22_ = g_strdup (_tmp18_);
			_g_free0 (from_name);
			from_name = _tmp22_;
		}
		_tmp23_ = geary_email_header_set_get_reply_to (email);
		_tmp24_ = _tmp23_;
		_tmp25_ = _g_object_ref0 (_tmp24_);
		reply_to = _tmp25_;
		primary_reply_to = NULL;
		_tmp26_ = g_strdup ("");
		reply_to_name = _tmp26_;
		_tmp28_ = reply_to;
		if (_tmp28_ != NULL) {
			GearyRFC822MailboxAddresses* _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
			_tmp29_ = reply_to;
			_tmp30_ = geary_rf_c822_mailbox_addresses_get_size (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp27_ = _tmp31_ > 0;
		} else {
			_tmp27_ = FALSE;
		}
		if (_tmp27_) {
			GearyRFC822MailboxAddresses* _tmp32_;
			GearyRFC822MailboxAddress* _tmp33_;
			const gchar* _tmp34_ = NULL;
			GearyRFC822MailboxAddress* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			_tmp32_ = reply_to;
			_tmp33_ = geary_rf_c822_mailbox_addresses_get (_tmp32_, 0);
			_g_object_unref0 (primary_reply_to);
			primary_reply_to = _tmp33_;
			_tmp35_ = primary_reply_to;
			_tmp36_ = geary_rf_c822_mailbox_address_get_name (_tmp35_);
			_tmp37_ = _tmp36_;
			_tmp34_ = _tmp37_;
			if (_tmp34_ == NULL) {
				_tmp34_ = "";
			}
			_tmp38_ = g_strdup (_tmp34_);
			_g_free0 (reply_to_name);
			reply_to_name = _tmp38_;
		}
		_tmp40_ = reply_to_name;
		if (g_strcmp0 (_tmp40_, "") != 0) {
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			_tmp41_ = from_name;
			_tmp42_ = reply_to_name;
			_tmp39_ = g_str_has_prefix (_tmp41_, _tmp42_);
		} else {
			_tmp39_ = FALSE;
		}
		if (_tmp39_) {
			GearyRFC822MailboxAddress* _tmp43_;
			GearyRFC822MailboxAddress* _tmp44_;
			_tmp43_ = primary_reply_to;
			_tmp44_ = _g_object_ref0 (_tmp43_);
			_g_object_unref0 (primary);
			primary = _tmp44_;
		} else {
			const gchar* _tmp45_;
			_tmp45_ = from_name;
			if (string_contains (_tmp45_, VIA)) {
				const gchar* _tmp46_;
				gchar** _tmp47_;
				gchar** _tmp48_;
				gchar** _tmp49_;
				gint _tmp49__length1;
				const gchar* _tmp50_;
				GearyRFC822MailboxAddress* _tmp51_;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				GearyRFC822MailboxAddress* _tmp54_;
				_tmp46_ = from_name;
				_tmp48_ = _tmp47_ = g_strsplit (_tmp46_, VIA, 2);
				_tmp49_ = _tmp48_;
				_tmp49__length1 = _vala_array_length (_tmp47_);
				_tmp50_ = _tmp49_[0];
				_tmp51_ = primary;
				_tmp52_ = geary_rf_c822_mailbox_address_get_address (_tmp51_);
				_tmp53_ = _tmp52_;
				_tmp54_ = geary_rf_c822_mailbox_address_new (_tmp50_, _tmp53_);
				_g_object_unref0 (primary);
				primary = _tmp54_;
				_tmp49_ = (_vala_array_free (_tmp49_, _tmp49__length1, (GDestroyNotify) g_free), NULL);
			}
		}
		_g_free0 (reply_to_name);
		_g_object_unref0 (primary_reply_to);
		_g_object_unref0 (reply_to);
		_g_free0 (from_name);
		_g_object_unref0 (from);
	} else {
		GearyRFC822MailboxAddress* _tmp55_;
		GearyRFC822MailboxAddress* _tmp56_;
		_tmp55_ = geary_email_header_set_get_sender (email);
		_tmp56_ = _tmp55_;
		if (_tmp56_ != NULL) {
			GearyRFC822MailboxAddress* _tmp57_;
			GearyRFC822MailboxAddress* _tmp58_;
			GearyRFC822MailboxAddress* _tmp59_;
			_tmp57_ = geary_email_header_set_get_sender (email);
			_tmp58_ = _tmp57_;
			_tmp59_ = _g_object_ref0 (_tmp58_);
			_g_object_unref0 (primary);
			primary = _tmp59_;
		} else {
			gboolean _tmp60_ = FALSE;
			GearyRFC822MailboxAddresses* _tmp61_;
			GearyRFC822MailboxAddresses* _tmp62_;
			_tmp61_ = geary_email_header_set_get_reply_to (email);
			_tmp62_ = _tmp61_;
			if (_tmp62_ != NULL) {
				GearyRFC822MailboxAddresses* _tmp63_;
				GearyRFC822MailboxAddresses* _tmp64_;
				gint _tmp65_;
				gint _tmp66_;
				_tmp63_ = geary_email_header_set_get_reply_to (email);
				_tmp64_ = _tmp63_;
				_tmp65_ = geary_rf_c822_mailbox_addresses_get_size (_tmp64_);
				_tmp66_ = _tmp65_;
				_tmp60_ = _tmp66_ > 0;
			} else {
				_tmp60_ = FALSE;
			}
			if (_tmp60_) {
				GearyRFC822MailboxAddresses* _tmp67_;
				GearyRFC822MailboxAddresses* _tmp68_;
				GearyRFC822MailboxAddress* _tmp69_;
				_tmp67_ = geary_email_header_set_get_reply_to (email);
				_tmp68_ = _tmp67_;
				_tmp69_ = geary_rf_c822_mailbox_addresses_get (_tmp68_, 0);
				_g_object_unref0 (primary);
				primary = _tmp69_;
			}
		}
	}
	result = primary;
	return result;
}

/**
     * Returns a shortened recipient list suitable for display.
     *
     * This is useful in case there are a lot of recipients, or there
     * is little room for the display.
     *
     * @return a string containing at least the first mailbox
     * serialised by {@link MailboxAddress.to_short_display}, if the
     * list contains more mailboxes then an indication of how many
     * additional are present.
     */
gchar*
util_email_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* first_recipient = NULL;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	const gchar* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gchar* _tmp14_;
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESSES (mailboxes), NULL);
	_tmp0_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == 0) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("(No recipients)"));
		result = _tmp2_;
		return result;
	}
	_tmp3_ = geary_rf_c822_mailbox_addresses_get (mailboxes, 0);
	_tmp4_ = _tmp3_;
	_tmp5_ = geary_rf_c822_mailbox_address_to_short_display (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp4_);
	first_recipient = _tmp6_;
	_tmp7_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp8_ = _tmp7_;
	if (_tmp8_ == 1) {
		result = first_recipient;
		return result;
	}
	_tmp9_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp10_ = _tmp9_;
	_tmp11_ = first_recipient;
	_tmp12_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strdup_printf (ngettext ("%s and %d other", "%s and %d others", (gulong) (_tmp10_ - 1)), _tmp11_, _tmp13_ - 1);
	result = _tmp14_;
	_g_free0 (first_recipient);
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

