/* util-js.c generated by valac 0.44.3, the Vala compiler
 * generated from util-js.vala, do not modify */

/*
 * Copyright 2017 Michael James Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <JavaScriptCore/JavaScript.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define GEARY_JS_TYPE_CALLABLE (geary_js_callable_get_type ())
#define GEARY_JS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_JS_TYPE_CALLABLE, GearyJSCallable))
#define GEARY_JS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_JS_TYPE_CALLABLE, GearyJSCallableClass))
#define GEARY_JS_IS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_JS_TYPE_CALLABLE))
#define GEARY_JS_IS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_JS_TYPE_CALLABLE))
#define GEARY_JS_CALLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_JS_TYPE_CALLABLE, GearyJSCallableClass))

typedef struct _GearyJSCallable GearyJSCallable;
typedef struct _GearyJSCallableClass GearyJSCallableClass;
typedef struct _GearyJSCallablePrivate GearyJSCallablePrivate;
typedef struct _GearyJSParamSpecCallable GearyJSParamSpecCallable;

/**
     * Errors produced by functions in {@link Geary.JS}.
     */
typedef enum  {
	GEARY_JS_ERROR_EXCEPTION,
	GEARY_JS_ERROR_TYPE
} GearyJSError;
#define GEARY_JS_ERROR geary_js_error_quark ()
struct _GearyJSCallable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GearyJSCallablePrivate * priv;
};

struct _GearyJSCallableClass {
	GTypeClass parent_class;
	void (*finalize) (GearyJSCallable *self);
};

struct _GearyJSCallablePrivate {
	gchar* base_name;
	gchar** safe_args;
	gint safe_args_length1;
	gint _safe_args_size_;
};

struct _GearyJSParamSpecCallable {
	GParamSpec parent_instance;
};

static gint GearyJSCallable_private_offset;
static gpointer geary_js_callable_parent_class = NULL;

GQuark geary_js_error_quark (void);
gboolean geary_js_is_null (const struct OpaqueJSContext* context,
                           const struct OpaqueJSValue* js);
gdouble geary_js_to_number (const struct OpaqueJSContext* context,
                            const struct OpaqueJSValue* value,
                            GError** error);
void geary_js_check_exception (const struct OpaqueJSContext* context,
                               const struct OpaqueJSValue* err_value,
                               GError** error);
gchar* geary_js_to_string (const struct OpaqueJSContext* context,
                           const struct OpaqueJSValue* value,
                           GError** error);
gchar* geary_js_to_native_string (struct OpaqueJSString* js);
struct OpaqueJSValue* geary_js_to_object (const struct OpaqueJSContext* context,
                                          const struct OpaqueJSValue* value,
                                          GError** error);
const struct OpaqueJSValue* geary_js_get_property (const struct OpaqueJSContext* context,
                                                   struct OpaqueJSValue* object,
                                                   const gchar* name,
                                                   GError** error);
const gchar* JS_type_to_string (JSType self);
static const char* _JS_type_to_string (JSType value);
gchar* geary_js_escape_string (const gchar* value);
gpointer geary_js_callable_ref (gpointer instance);
void geary_js_callable_unref (gpointer instance);
GParamSpec* geary_js_param_spec_callable (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void geary_js_value_set_callable (GValue* value,
                                  gpointer v_object);
void geary_js_value_take_callable (GValue* value,
                                   gpointer v_object);
gpointer geary_js_value_get_callable (const GValue* value);
GType geary_js_callable_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyJSCallable, geary_js_callable_unref)
GearyJSCallable* geary_js_callable (const gchar* base_name);
GearyJSCallable* geary_js_callable_new (const gchar* base_name);
GearyJSCallable* geary_js_callable_construct (GType object_type,
                                              const gchar* base_name);
gchar* geary_js_callable_to_string (GearyJSCallable* self);
GearyJSCallable* geary_js_callable_string (GearyJSCallable* self,
                                           const gchar* value);
static inline void geary_js_callable_add_param (GearyJSCallable* self,
                                  const gchar* value);
GearyJSCallable* geary_js_callable_double (GearyJSCallable* self,
                                           gdouble value);
GearyJSCallable* geary_js_callable_int (GearyJSCallable* self,
                                        gint value);
GearyJSCallable* geary_js_callable_bool (GearyJSCallable* self,
                                         gboolean value);
static void _vala_array_add24 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void geary_js_callable_finalize (GearyJSCallable * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

GQuark
geary_js_error_quark (void)
{
	return g_quark_from_static_string ("geary-js-error-quark");
}

/**
     * Determines if a {@link JS.Value} object is {{{null}}}.
     *
     * @return `true` if `js` is `null` or has a {@link JS.Type} of
     * `NULL` according to `context`.
     */
inline gboolean
geary_js_is_null (const struct OpaqueJSContext* context,
                  const struct OpaqueJSValue* js)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (context != NULL, FALSE);
	if (js == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = JSValueGetType (context, js) == kJSTypeNull;
	}
	result = _tmp0_;
	return result;
}

/**
     * Returns a JSC Value as a number.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
gdouble
geary_js_to_number (const struct OpaqueJSContext* context,
                    const struct OpaqueJSValue* value,
                    GError** error)
{
	gdouble result = 0.0;
	const struct OpaqueJSValue* err = NULL;
	gdouble number = 0.0;
	const struct OpaqueJSValue* _tmp3_ = NULL;
	gdouble _tmp4_;
	const struct OpaqueJSValue* _tmp5_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (context != NULL, 0.0);
	g_return_val_if_fail (value != NULL, 0.0);
	if (!JSValueIsNumber (context, value)) {
		GError* _tmp0_;
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS Number object");
		_inner_error0_ = _tmp0_;
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
			gdouble _tmp1_ = -1.0;
			g_propagate_error (error, _inner_error0_);
			return _tmp1_;
		} else {
			gdouble _tmp2_ = -1.0;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp2_;
		}
	}
	err = NULL;
	_tmp4_ = JSValueToNumber (context, value, &_tmp3_);
	_0 (err);
	err = _tmp3_;
	number = _tmp4_;
	_tmp5_ = err;
	geary_js_check_exception (context, _tmp5_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
			gdouble _tmp6_ = -1.0;
			g_propagate_error (error, _inner_error0_);
			_0 (err);
			return _tmp6_;
		} else {
			gdouble _tmp7_ = -1.0;
			_0 (err);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp7_;
		}
	}
	result = number;
	_0 (err);
	return result;
}

/**
     * Returns a JSC Value as a string.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `String`.
     */
gchar*
geary_js_to_string (const struct OpaqueJSContext* context,
                    const struct OpaqueJSValue* value,
                    GError** error)
{
	gchar* result = NULL;
	const struct OpaqueJSValue* err = NULL;
	struct OpaqueJSString* js_str = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	struct OpaqueJSString* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (context != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	if (!JSValueIsString (context, value)) {
		GError* _tmp0_;
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS String object");
		_inner_error0_ = _tmp0_;
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	err = NULL;
	_tmp2_ = JSValueToStringCopy (context, value, &_tmp1_);
	_0 (err);
	err = _tmp1_;
	js_str = _tmp2_;
	_tmp3_ = err;
	geary_js_check_exception (context, _tmp3_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_JSStringRelease0 (js_str);
			_0 (err);
			return NULL;
		} else {
			_JSStringRelease0 (js_str);
			_0 (err);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = geary_js_to_native_string (js_str);
	result = _tmp4_;
	_JSStringRelease0 (js_str);
	_0 (err);
	return result;
}

/**
     * Returns a JSC Value as an object.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `Object`.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
struct OpaqueJSValue*
geary_js_to_object (const struct OpaqueJSContext* context,
                    const struct OpaqueJSValue* value,
                    GError** error)
{
	struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSValue* err = NULL;
	struct OpaqueJSValue* js_obj = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	struct OpaqueJSValue* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (context != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	if (!JSValueIsObject (context, value)) {
		GError* _tmp0_;
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS Object");
		_inner_error0_ = _tmp0_;
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	err = NULL;
	_tmp2_ = JSValueToObject (context, value, &_tmp1_);
	_0 (err);
	err = _tmp1_;
	js_obj = _tmp2_;
	_tmp3_ = err;
	geary_js_check_exception (context, _tmp3_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_0 (js_obj);
			_0 (err);
			return NULL;
		} else {
			_0 (js_obj);
			_0 (err);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = js_obj;
	_0 (err);
	return result;
}

/**
     * Returns a JSC {@link JS.String} as a Vala {@link string}.
     */
inline gchar*
geary_js_to_native_string (struct OpaqueJSString* js)
{
	gchar* result = NULL;
	gsize len = 0UL;
	guint8* str = NULL;
	guint8* _tmp0_;
	gint str_length1;
	gint _str_size_;
	gchar* _tmp1_;
	g_return_val_if_fail (js != NULL, NULL);
	len = JSStringGetMaximumUTF8CStringSize (js);
	_tmp0_ = g_new0 (guint8, len);
	str = _tmp0_;
	str_length1 = len;
	_str_size_ = str_length1;
	JSStringGetUTF8CString (js, str, (gsize) str_length1);
	_tmp1_ = g_strdup ((const gchar*) str);
	result = _tmp1_;
	str = (g_free (str), NULL);
	return result;
}

/**
     * Returns the value of an object's property.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * object does not contain the named property.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
inline const struct OpaqueJSValue*
geary_js_get_property (const struct OpaqueJSContext* context,
                       struct OpaqueJSValue* object,
                       const gchar* name,
                       GError** error)
{
	const struct OpaqueJSValue* result = NULL;
	struct OpaqueJSString* js_name = NULL;
	struct OpaqueJSString* _tmp0_;
	const struct OpaqueJSValue* err = NULL;
	const struct OpaqueJSValue* prop = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	const struct OpaqueJSValue* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (context != NULL, NULL);
	g_return_val_if_fail (object != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = JSStringCreateWithUTF8CString (name);
	js_name = _tmp0_;
	err = NULL;
	_tmp2_ = JSObjectGetProperty (context, object, js_name, &_tmp1_);
	_0 (err);
	err = _tmp1_;
	prop = _tmp2_;
	_tmp3_ = err;
	geary_js_check_exception (context, _tmp3_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_0 (prop);
			_0 (err);
			_JSStringRelease0 (js_name);
			return NULL;
		} else {
			_0 (prop);
			_0 (err);
			_JSStringRelease0 (js_name);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = prop;
	_0 (err);
	_JSStringRelease0 (js_name);
	return result;
}

/**
     * Checks an JS exception returned from a JSC call.
     *
     * This method will raise a {@link Geary.JS.Error} if the given
     * `err_value` is not null (in a Vala or JS sense).
     */
static const char*
_JS_type_to_string (JSType value)
{
	switch (value) {
		case kJSTypeUndefined:
		return "kJSTypeUndefined";
		case kJSTypeNull:
		return "kJSTypeNull";
		case kJSTypeBoolean:
		return "kJSTypeBoolean";
		case kJSTypeNumber:
		return "kJSTypeNumber";
		case kJSTypeString:
		return "kJSTypeString";
		case kJSTypeObject:
		return "kJSTypeObject";
	}
	return NULL;
}

inline void
geary_js_check_exception (const struct OpaqueJSContext* context,
                          const struct OpaqueJSValue* err_value,
                          GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (context != NULL);
	if (!geary_js_is_null (context, err_value)) {
		const struct OpaqueJSValue* nested_err = NULL;
		JSType err_type = 0;
		struct OpaqueJSString* err_str = NULL;
		const struct OpaqueJSValue* _tmp0_ = NULL;
		struct OpaqueJSString* _tmp1_;
		const struct OpaqueJSValue* _tmp2_;
		JSType _tmp6_;
		const gchar* _tmp7_;
		struct OpaqueJSString* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GError* _tmp13_;
		GError* _tmp14_;
		nested_err = NULL;
		err_type = JSValueGetType (context, err_value);
		_tmp1_ = JSValueToStringCopy (context, err_value, &_tmp0_);
		_0 (nested_err);
		nested_err = _tmp0_;
		err_str = _tmp1_;
		_tmp2_ = nested_err;
		if (!geary_js_is_null (context, _tmp2_)) {
			JSType _tmp3_;
			const gchar* _tmp4_;
			GError* _tmp5_;
			_tmp3_ = err_type;
			_tmp4_ = _JS_type_to_string (_tmp3_);
			_tmp5_ = g_error_new (GEARY_JS_ERROR, GEARY_JS_ERROR_EXCEPTION, "Nested exception getting exception %s as a string", _tmp4_);
			_inner_error0_ = _tmp5_;
			if (_inner_error0_->domain == GEARY_JS_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_JSStringRelease0 (err_str);
				_0 (nested_err);
				return;
			} else {
				_JSStringRelease0 (err_str);
				_0 (nested_err);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp6_ = err_type;
		_tmp7_ = _JS_type_to_string (_tmp6_);
		_tmp8_ = err_str;
		_tmp9_ = geary_js_to_native_string (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strdup_printf ("JS exception thrown [%s]: %s", _tmp7_, _tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_EXCEPTION, _tmp12_);
		_tmp14_ = _tmp13_;
		_g_free0 (_tmp12_);
		_g_free0 (_tmp10_);
		_inner_error0_ = _tmp14_;
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_JSStringRelease0 (err_str);
			_0 (nested_err);
			return;
		} else {
			_JSStringRelease0 (err_str);
			_0 (nested_err);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_JSStringRelease0 (err_str);
		_0 (nested_err);
	}
}

/**
     * Escapes a string so as to be safe to use as a JS string literal.
     *
     * This does not append opening or closing quotes.
     */
static gboolean
string_valid_char (const gchar* self,
                   gint index)
{
	gboolean result = FALSE;
	guint8 c = 0U;
	guint8 _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = ((guint8*) self)[index];
	c = _tmp0_;
	if (((gint) c) == 0x00) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp3_ = FALSE;
		if (((gint) c) >= 0x80) {
			_tmp3_ = ((gint) c) < 0xc2;
		} else {
			_tmp3_ = FALSE;
		}
		_tmp2_ = _tmp3_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = ((gint) c) >= 0xf5;
	}
	if (_tmp1_) {
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	result = g_utf8_get_char (((gchar*) self) + index);
	return result;
}

static guint8*
g_string_get_data (GString* self,
                   gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->str;
	res = (guint8*) _tmp0_;
	res_length1 = -1;
	_res_size_ = res_length1;
	res_length1 = (gint) self->len;
	_tmp1_ = res;
	_tmp1__length1 = res_length1;
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

gchar*
geary_js_escape_string (const gchar* value)
{
	gchar* result = NULL;
	GString* builder = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GString* _tmp2_;
	GString* _tmp18_;
	guint8* _tmp19_;
	gint _tmp19__length1;
	guint8* _tmp20_;
	gint _tmp20__length1;
	gchar* _tmp21_;
	g_return_val_if_fail (value != NULL, NULL);
	_tmp0_ = strlen (value);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_string_sized_new ((gsize) _tmp1_);
	builder = _tmp2_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gint _tmp6_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = strlen (value);
				_tmp6_ = _tmp5_;
				if (!(i < _tmp6_)) {
					break;
				}
				if (string_valid_char (value, i)) {
					gunichar c = 0U;
					c = string_get_char (value, (glong) i);
					switch (c) {
						case '\x00':
						{
							GString* _tmp7_;
							_tmp7_ = builder;
							g_string_append (_tmp7_, "\x00");
							break;
						}
						case '\'':
						{
							GString* _tmp8_;
							_tmp8_ = builder;
							g_string_append (_tmp8_, "\\\'");
							break;
						}
						case '"':
						{
							GString* _tmp9_;
							_tmp9_ = builder;
							g_string_append (_tmp9_, "\\\"");
							break;
						}
						case '\\':
						{
							GString* _tmp10_;
							_tmp10_ = builder;
							g_string_append (_tmp10_, "\\\\");
							break;
						}
						case '\n':
						{
							GString* _tmp11_;
							_tmp11_ = builder;
							g_string_append (_tmp11_, "\\n");
							break;
						}
						case '\r':
						{
							GString* _tmp12_;
							_tmp12_ = builder;
							g_string_append (_tmp12_, "\\r");
							break;
						}
						case '\x0b':
						{
							GString* _tmp13_;
							_tmp13_ = builder;
							g_string_append (_tmp13_, "\x0b");
							break;
						}
						case '\t':
						{
							GString* _tmp14_;
							_tmp14_ = builder;
							g_string_append (_tmp14_, "\\t");
							break;
						}
						case '\b':
						{
							GString* _tmp15_;
							_tmp15_ = builder;
							g_string_append (_tmp15_, "\\b");
							break;
						}
						case '\f':
						{
							GString* _tmp16_;
							_tmp16_ = builder;
							g_string_append (_tmp16_, "\\f");
							break;
						}
						default:
						{
							GString* _tmp17_;
							_tmp17_ = builder;
							g_string_append_unichar (_tmp17_, c);
							break;
						}
					}
				}
			}
		}
	}
	_tmp18_ = builder;
	_tmp19_ = g_string_get_data (_tmp18_, &_tmp19__length1);
	_tmp20_ = _tmp19_;
	_tmp20__length1 = _tmp19__length1;
	_tmp21_ = g_strdup ((const gchar*) _tmp20_);
	result = _tmp21_;
	_g_string_free0 (builder);
	return result;
}

/**
     * Convenience method for returning a new Callable instance.
     */
GearyJSCallable*
geary_js_callable (const gchar* base_name)
{
	GearyJSCallable* result = NULL;
	GearyJSCallable* _tmp0_;
	g_return_val_if_fail (base_name != NULL, NULL);
	_tmp0_ = geary_js_callable_new (base_name);
	result = _tmp0_;
	return result;
}

static inline gpointer
geary_js_callable_get_instance_private (GearyJSCallable* self)
{
	return G_STRUCT_MEMBER_P (self, GearyJSCallable_private_offset);
}

GearyJSCallable*
geary_js_callable_construct (GType object_type,
                             const gchar* base_name)
{
	GearyJSCallable* self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (base_name != NULL, NULL);
	self = (GearyJSCallable*) g_type_create_instance (object_type);
	_tmp0_ = g_strdup (base_name);
	_g_free0 (self->priv->base_name);
	self->priv->base_name = _tmp0_;
	return self;
}

GearyJSCallable*
geary_js_callable_new (const gchar* base_name)
{
	return geary_js_callable_construct (GEARY_JS_TYPE_CALLABLE, base_name);
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len = len + _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len = len + (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp19_ = res;
		_tmp20_ = str_array[0];
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
		ptr = _tmp21_;
		{
			gboolean _tmp22_ = FALSE;
			i = 1;
			_tmp22_ = TRUE;
			while (TRUE) {
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp24_ = ptr;
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
				ptr = _tmp25_;
				_tmp27_ = str_array[i];
				if (_tmp27_ != NULL) {
					const gchar* _tmp28_;
					_tmp28_ = str_array[i];
					_tmp26_ = (const gchar*) _tmp28_;
				} else {
					_tmp26_ = "";
				}
				_tmp29_ = ptr;
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
				ptr = _tmp30_;
			}
		}
		_tmp31_ = res;
		res = NULL;
		result = (gchar*) _tmp31_;
		return result;
	} else {
		gchar* _tmp32_;
		_tmp32_ = g_strdup ("");
		result = _tmp32_;
		return result;
	}
}

gchar*
geary_js_callable_to_string (GearyJSCallable* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
	_tmp0_ = self->priv->base_name;
	_tmp1_ = g_strconcat (_tmp0_, "(", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->safe_args;
	_tmp3__length1 = self->priv->safe_args_length1;
	_tmp4_ = _vala_g_strjoinv (",", _tmp3_, (gint) _tmp3__length1);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat (_tmp7_, ");", NULL);
	_tmp9_ = _tmp8_;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp2_);
	result = _tmp9_;
	return result;
}

static gpointer
_geary_js_callable_ref0 (gpointer self)
{
	return self ? geary_js_callable_ref (self) : NULL;
}

GearyJSCallable*
geary_js_callable_string (GearyJSCallable* self,
                          const gchar* value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GearyJSCallable* _tmp6_;
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
	g_return_val_if_fail (value != NULL, NULL);
	_tmp0_ = geary_js_escape_string (value);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat ("\"", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (_tmp3_, "\"", NULL);
	_tmp5_ = _tmp4_;
	geary_js_callable_add_param (self, _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	_tmp6_ = _geary_js_callable_ref0 (self);
	result = _tmp6_;
	return result;
}

static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}

GearyJSCallable*
geary_js_callable_double (GearyJSCallable* self,
                          gdouble value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyJSCallable* _tmp2_;
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
	_tmp0_ = double_to_string (value);
	_tmp1_ = _tmp0_;
	geary_js_callable_add_param (self, _tmp1_);
	_g_free0 (_tmp1_);
	_tmp2_ = _geary_js_callable_ref0 (self);
	result = _tmp2_;
	return result;
}

GearyJSCallable*
geary_js_callable_int (GearyJSCallable* self,
                       gint value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyJSCallable* _tmp2_;
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
	_tmp0_ = g_strdup_printf ("%i", value);
	_tmp1_ = _tmp0_;
	geary_js_callable_add_param (self, _tmp1_);
	_g_free0 (_tmp1_);
	_tmp2_ = _geary_js_callable_ref0 (self);
	result = _tmp2_;
	return result;
}

GearyJSCallable*
geary_js_callable_bool (GearyJSCallable* self,
                        gboolean value)
{
	GearyJSCallable* result = NULL;
	const gchar* _tmp0_ = NULL;
	GearyJSCallable* _tmp1_;
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
	if (value) {
		_tmp0_ = "true";
	} else {
		_tmp0_ = "false";
	}
	geary_js_callable_add_param (self, _tmp0_);
	_tmp1_ = _geary_js_callable_ref0 (self);
	result = _tmp1_;
	return result;
}

static void
_vala_array_add24 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static inline void
geary_js_callable_add_param (GearyJSCallable* self,
                             const gchar* value)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	g_return_if_fail (GEARY_JS_IS_CALLABLE (self));
	g_return_if_fail (value != NULL);
	_tmp0_ = self->priv->safe_args;
	_tmp0__length1 = self->priv->safe_args_length1;
	_tmp1_ = g_strdup (value);
	_vala_array_add24 (&self->priv->safe_args, &self->priv->safe_args_length1, &self->priv->_safe_args_size_, _tmp1_);
}

static void
geary_js_value_callable_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
geary_js_value_callable_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		geary_js_callable_unref (value->data[0].v_pointer);
	}
}

static void
geary_js_value_callable_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = geary_js_callable_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
geary_js_value_callable_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
geary_js_value_callable_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GearyJSCallable * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = geary_js_callable_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
geary_js_value_callable_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	GearyJSCallable ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = geary_js_callable_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
geary_js_param_spec_callable (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	GearyJSParamSpecCallable* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_JS_TYPE_CALLABLE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
geary_js_value_get_callable (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE), NULL);
	return value->data[0].v_pointer;
}

void
geary_js_value_set_callable (GValue* value,
                             gpointer v_object)
{
	GearyJSCallable * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_JS_TYPE_CALLABLE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		geary_js_callable_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		geary_js_callable_unref (old);
	}
}

void
geary_js_value_take_callable (GValue* value,
                              gpointer v_object)
{
	GearyJSCallable * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_JS_TYPE_CALLABLE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		geary_js_callable_unref (old);
	}
}

static void
geary_js_callable_class_init (GearyJSCallableClass * klass,
                              gpointer klass_data)
{
	geary_js_callable_parent_class = g_type_class_peek_parent (klass);
	((GearyJSCallableClass *) klass)->finalize = geary_js_callable_finalize;
	g_type_class_adjust_private_offset (klass, &GearyJSCallable_private_offset);
}

static void
geary_js_callable_instance_init (GearyJSCallable * self,
                                 gpointer klass)
{
	gchar** _tmp0_;
	self->priv = geary_js_callable_get_instance_private (self);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	self->priv->safe_args = _tmp0_;
	self->priv->safe_args_length1 = 0;
	self->priv->_safe_args_size_ = self->priv->safe_args_length1;
	self->ref_count = 1;
}

static void
geary_js_callable_finalize (GearyJSCallable * obj)
{
	GearyJSCallable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_JS_TYPE_CALLABLE, GearyJSCallable);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->base_name);
	self->priv->safe_args = (_vala_array_free (self->priv->safe_args, self->priv->safe_args_length1, (GDestroyNotify) g_free), NULL);
}

/**
     * A class for constructing a well formed, safe, invokable JS call.
     */
GType
geary_js_callable_get_type (void)
{
	static volatile gsize geary_js_callable_type_id__volatile = 0;
	if (g_once_init_enter (&geary_js_callable_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { geary_js_value_callable_init, geary_js_value_callable_free_value, geary_js_value_callable_copy_value, geary_js_value_callable_peek_pointer, "p", geary_js_value_callable_collect_value, "p", geary_js_value_callable_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GearyJSCallableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_js_callable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyJSCallable), 0, (GInstanceInitFunc) geary_js_callable_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType geary_js_callable_type_id;
		geary_js_callable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearyJSCallable", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GearyJSCallable_private_offset = g_type_add_instance_private (geary_js_callable_type_id, sizeof (GearyJSCallablePrivate));
		g_once_init_leave (&geary_js_callable_type_id__volatile, geary_js_callable_type_id);
	}
	return geary_js_callable_type_id__volatile;
}

gpointer
geary_js_callable_ref (gpointer instance)
{
	GearyJSCallable * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
geary_js_callable_unref (gpointer instance)
{
	GearyJSCallable * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GEARY_JS_CALLABLE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

